<?php

namespace Drupal\liqpay\Controller;

use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;
use Drupal\Core\Url;

class LiqpayPages{
     
     protected $liqPay;
     protected $basket;
     protected $request;
     protected $moduleHandler;

     function __construct() {
          $this->liqPay = \Drupal::service('LiqPay');
          $this->basket = \Drupal::hasService('Basket') ? \Drupal::service('Basket') : NULL;
          $this->request = \Drupal::request()->query->all();
          $this->moduleHandler = \Drupal::moduleHandler();
     }

     public function title(array $_title_arguments = array(), $_title = ''){
          return $this->liqPay->t($_title);
     }
	public function pages($page_type, $all = []){
          $element = [];
          switch($page_type){
               case'api':
                    if(!empty($_REQUEST['data']) && !empty($_REQUEST['signature'])){
                         $config = $this->liqPay->getConfig();
                         // ---
                         $data = json_decode(base64_decode($_REQUEST['data']), TRUE);
                         list($order_id, $rand) = explode('-', $data['order_id']);
                         $payment = $this->liqPay->load([
                                'id'      => $data['order_id']
                         ]);
                         $params = [];
                         // Alter
                         $this->moduleHandler->alter('liqpay_payment_params', $params, $payment, $config);
                         // ---
                         $signature = base64_encode(sha1($config['private_key'].$_REQUEST['data'].$config['private_key'],1));
                 		if($signature == $_REQUEST['signature']){
                              $payment = $this->liqPay->load([
                                     'id'      => $data['order_id']
                              ]);
                              if(!empty($data['order_id'])){
                                   if(!empty($payment->id)){
                                        $pre_pay = @unserialize($payment->data);
                                        $data['pre_pay'] = !empty($pre_pay['pre_pay']) ? $pre_pay['pre_pay'] : $pre_pay;
                                        // ---
                                        $payment->paytime = time();
                                        $payment->data = serialize($data);
                                        // ---
                                        if(!empty($data['status'])){
                                             $payment->status = $data['status'];
                                             $successes = explode('|', $this->liqPay::LIQPAY_SUCCESS_STATUS);
                                             if(in_array($data['status'], $successes)){
                                                  if(!empty($this->basket)) {
                                                       if(method_exists($this->basket, 'paymentFinish')) {
                                                            $this->basket->paymentFinish($payment->nid);
                                                       }
                                                  }
                                             }
                                        }
                                        $this->liqPay->update($payment);
                                        // Alter
                                        $this->moduleHandler->alter('liqpay_api', $payment, $fields);
                                        // Trigger change payment status by order
                                        if(!empty($payment->nid) && !empty($this->basket)){
                                             $order = $this->basket->Orders(NULL, $payment->nid)->load();
                                             if(!empty($order) && $this->moduleHandler->moduleExists('basket_noty')){
                                                  \Drupal::service('BasketNoty')->trigger('change_liqpay_status', [
                                                       'order'     => $order
                                                  ]);
                                             }
                                        }
                                   }
                              }
                         }
                 	}
               break;
               case'pay':
                    $is_404 = TRUE;
                    if(!empty($this->request['pay_id'])){
                         $payment = $this->liqPay->load([
                              'id'      => $this->request['pay_id']
                         ]);
                         $successes = explode('|', $this->liqPay::LIQPAY_SUCCESS_STATUS);
                         if(!empty($payment->status) && !in_array($payment->status, $successes)){
                             $is_404 = FALSE;
                             $element['form'] = \Drupal::formBuilder()->getForm('\Drupal\liqpay\Form\PaymentForm', $payment);
                         }
                    } 
                    if($is_404){
                         throw new NotFoundHttpException();
                    }
               break;
               case'payment_result':
                    $element['#title'] = $this->liqPay->t('Payment result');
                    $payON = FALSE;
                    if(!empty($_SESSION['liqpay_last_pay'])){
                         $payment = $this->liqPay->load(['id' => $_SESSION['liqpay_last_pay']]);
                         $successes = explode('|', $this->liqPay::LIQPAY_SUCCESS_STATUS);
                         if(!empty($payment->status) && in_array($payment->status, $successes)){
                              $payON = TRUE;
                         }
                         if(!$payON){
                              $getStatus = $this->liqPay->getStatus($_SESSION['liqpay_last_pay']);
                              if(!empty($getStatus->code) && $getStatus->code !== 'payment_not_found'){
                                   $payON = TRUE;
                              }
                         }
                         if($payON){
                              $config = $this->liqPay->getConfig();
                              $langcode = \Drupal::languageManager()->getCurrentLanguage()->getId();
                              $success = !empty($config['success'][$langcode]) ? $config['success'][$langcode] : $config['success']['en'];
                              if($payment->status == 'unsubscribed'){
                                   $success['value'] = '<p class="text-align-center"><strong>Подписка успешно деактивирована.</strong></p>';
                              }
                              $element += [
                                   '#theme'       => 'liqpay_success_page',
                                   '#info'        => [
                                        'text'         => [
                                             '#type'         => 'processed_text',
                                             '#text'         => !empty($success['value']) ? $success['value'] : '',
                                             '#format'       => !empty($success['format']) ? $success['format'] : NULL,
                                        ],
                                        'type'         => 'success'
                                   ],
                                   '#attached'    => [
                                        'library'      => [
                                             'liqpay/css'
                                        ]
                                   ]
                              ];
                         } else {
                              $element += [
                                   '#theme'       => 'liqpay_success_page',
                                   '#info'        => [
                                        'text'         => [
                                             'text'         => [
                                                  '#type'         => 'processed_text',
                                                  '#text'         => '<p class="text-align-center"><strong>'.$this->liqPay->t('No payment data.').'</strong></p>',
                                                  '#format'       => 'full_html',
                                             ],
                                             'link'         => [
                                                  '#type'        => 'link',
                                                  '#title'       => $this->liqPay->t('Repeat'),
                                                  '#url'         => new Url('liqpay.pages', [
                                                       'page_type'    => 'pay'
                                                  ],[
                                                       'attributes'   => [
                                                            'class'        => ['form-submit']
                                                       ],
                                                       'query'        => [
                                                            'pay_id'       => $_SESSION['liqpay_last_pay']
                                                       ]
                                                  ])
                                             ],
                                        ],
                                        'type'         => 'error'
                                   ],
                                   '#attached'    => [
                                        'library'      => [
                                             'liqpay/css'
                                        ]
                                   ]
                              ];
                         }
                    }
               break;
          }
    	     return $element;
  	}
}